
// Gives us access to all functions in the 'system' namespace
using System;

class Instance {

	// A public method with the same name as the class is known as a constructor
	// and gives a programmer a way to pass paramters to a new instance of a class
	// These normally aid in initialisation
	
	public Instance(int instanceNumber) {
		Console.Write("Hello I am instance {0} of the Instance class\n", instanceNumber);
	}


	// The method 'MAIN' is the entry point into an executable program
	// The method is 'static' because it refers to the class,
	// not any instances of the class.
	public static int Main(){
	
			// We enter the 'static' Main method of the CLASS first
			// At this point, no INSTANCES of the class exist
			Console.Write("Just entered the main method\n");
				
			// Now we create two instances of the 'Instance' class, one
			// of which will will be referenced through the 'object' type which is
			// similar to VB's variant type which can point to most data types.
			// The other instance will actually be set to being as type
			// 'Instance'
			
			Instance instance1 = new Instance(1);
			object instance2 = new Instance(2);
			
			// The ToString method will ask an object to tell you its class
			Console.Write("instance1 points to an instance of {0}\n", instance1.ToString());
			Console.Write("instance2 points to an instance of {0}\n", instance2.ToString());
			
			return 1; // any int value will do
 
	}
}

	
