
// Gives us access to all functions in the 'system' namespace
using System;

class Arrays {

	// This class will ask for your name, then
	// display it
	
	public static int Main(){
	
			Console.Write("\n"); // new line
	
			// below are 2 ways to populate single dimensional arrays
			// FIRST WAY
			int[] singleDimensionalArray = new int[6];
			singleDimensionalArray [0] = 3;
			singleDimensionalArray [1] = 5;
			// SECOND WAY
			int[] MyLotteryNumbers = {3, 5, 13, 18, 27, 34};
			
			// declare a multidimensional array
			int[,] MyFamiliesLotteryNumbers = new int[3,6];
			
			// populate it with first family member's lottery numbers
			MyFamiliesLotteryNumbers[0,0] = 3;
			MyFamiliesLotteryNumbers[0,1] = 5;
			MyFamiliesLotteryNumbers[0,2] = 13; 
			MyFamiliesLotteryNumbers[0,3] = 18;
			MyFamiliesLotteryNumbers[0,4] = 27;
			MyFamiliesLotteryNumbers[0,5] = 34;
			
			// populate it with second family member's lottery numbers
			MyFamiliesLotteryNumbers[1,0] = 7;
			MyFamiliesLotteryNumbers[1,1] = 8;
			MyFamiliesLotteryNumbers[1,2] = 32; 
			MyFamiliesLotteryNumbers[1,3] = 39;
			MyFamiliesLotteryNumbers[1,4] = 44;
			MyFamiliesLotteryNumbers[1,5] = 49;
			
			// populate it with third family member's lottery numbers
			MyFamiliesLotteryNumbers[2,0] = 1;
			MyFamiliesLotteryNumbers[2,1] = 11;
			MyFamiliesLotteryNumbers[2,2] = 14; 
			MyFamiliesLotteryNumbers[2,3] = 18;
			MyFamiliesLotteryNumbers[2,4] = 22;
			MyFamiliesLotteryNumbers[2,5] = 46;
			
			// an example of printing my first lottery number, and family
			// member '2''s last lottery number
			Console.Write("My first lottery number is {0}\n", MyLotteryNumbers[0]);
			Console.Write("Family member 2's last number is {0}\n", MyFamiliesLotteryNumbers[2,5]);

			
			
			// -------------- JAGGED ARRAYS ---------------
			
			// The syntax for creating a jagged array is as follows:
			//
			// TYPE [dimensions of jagged array denoted by number of commas or no comma]
			// [dimensions of array that jagged array elements encase denoted by commas/no comma] = new
			// TYPE [actual dimensions of jagged array] 
			// [dimensions of array that jagged array elements encase denoted by commas/no comma]
			
			// This means that int [,,][] would signify that we are creating a 3d jagged
			// array whose elements point to 1d arrays.  If the statement continues...
			// int [,,][] arrayname = new int[1,1,1][] then we would simply be adding in
			// the details of the dimensions
			
			
			// Firstly, a 1d jagged array that contains two 1d arrays,
			// the first being a 1d array 4 elements in size, and the second
			// being a 1d array 2 elements in size
			
			int [][] MyJaggedArray = new int[2][]; // 2 rows in this jagged array
			
			MyJaggedArray[0] = new int[4]; // element contains 1d array
			MyJaggedArray[1] = new int[2]; // element contains 1d array
			
			// Now we access the first element in the array contained in
			// MyJaggedArray slot [0]:
			
			MyJaggedArray[0][0] = 5;
			Console.Write("MyJaggedArray[0][0] contains the value {0}\n", MyJaggedArray[0][0]);
			
			
			
			// Secondly, a 2d jagged array that contains four 1d arrays
			// sizing 4, 2, 8 and 2 elements respectively
			
			int[,][] MyJaggedArray2 = new int[2,2][]; // 2 rows, 2 cols in this jagged array
			
			MyJaggedArray2[0,0] = new int[4]; // element contains 1d array
			MyJaggedArray2[0,1] = new int[2]; // element contains 1d array
			MyJaggedArray2[1,0] = new int[8]; // element contains 1d array
			MyJaggedArray2[1,1] = new int[2]; // element contains 1d array
			
			// Now we access the first element in the array contained in
			// MyJaggedArray2 slot [0,0]:
			
			MyJaggedArray2[0,0][0] = 900;
			Console.Write("MyJaggedArray2[0,0][0] contains the value {0}\n", MyJaggedArray2[0,0][0]);
			
			
			
			
			// Finally a 2d jagged array that contains four 2d arrays
			// sizing [4,2], [2,2], [9,9] and [3,1] elements respectively

			int[,][,] MyJaggedArray3 = new int[2,2][,]; // 2 rows, 2 cols in this jagged array
			
			
			MyJaggedArray3[0,0] = new int[4,2]; // element contains 2d array
			MyJaggedArray3[0,1] = new int[2,2]; // element contains 2d array
			MyJaggedArray3[1,0] = new int[9,9]; // element contains 2d array
			MyJaggedArray3[1,1] = new int[3,1]; // element contains 2d array
			
			// Now we access element [8,8] in the array contained in
			// MyJaggedArray3 slot [1,0]:
			
			MyJaggedArray3[1,0][8,8] = -3;
			Console.Write("MyJaggedArray2[1,0][8,8] contains the value {0}\n", MyJaggedArray3[1,0][8,8]);
			
			// Please be aware that jagged arrays can only store data that is
			// of the same kind (i.e. all 'int' or all 'char' for example).
						
			return 1; // any int value will do
 
	}
}

	
