
// Gives us access to all functions in the 'system' namespace
using System;

// Abstract class - cannot create an instance of this
abstract class AbstractClass {

	// abstract classes can still have constructors
	// but these only ever get called when a derived
	// class's constructor is called
	public AbstractClass(){
		Console.Write("\nBase constructor called");
	}

	// abstract methods are implicitly virtual
	public abstract void AnAbstractMethod();
}

sealed class SealedClass{

	// no derivation possible using this class
	// Complete opposite of an abstract class
	// as this prohibits derivation, while
	// abstract classes mandate it.
	
	public int value=0;

}

class InheritsAbstract : AbstractClass {

	// Constructor
	public InheritsAbstract(){
		Console.Write("\nClient constructor called");
	}
	
	public override void AnAbstractMethod(){
		Console.Write("\nAnAbstractMethod called from client");
	}

}

// uncomment this class to cause errors
//class TryToInheritSealed : SealedClass {
	// class details would go here ...
//}

class GettingStuckIntoClasses4{
		
	public static void Main(){	
		
		// declare an instance of the InheritsAbstractClass
		InheritsAbstract derivedclass = new InheritsAbstract();
		
		// Now call the overriden method
		derivedclass.AnAbstractMethod();
		
		// UnComment next line to cause an error
		// AbstractClass baseclass = new AbstractClass();
		
		// This is legal, however, due to Polymorphism:
		AbstractClass referenceToDerived = new InheritsAbstract();
		referenceToDerived.AnAbstractMethod();
				
	}
}
